var _ = require('underscore')._
  , assert = require('assert')
  , header, request, status

exports.header = header = function(name, value) {
  return function(err, res) {
    assert.isNull(err)
    assert.equal(res.headers[name], value)
  }
}

exports.status = status = function(code) {
  return function(err, res) {
    assert.isNull(err)
    assert.equal(res.statusCode, code)
  }
}

exports.request = request = function(request, response, vows) {
  var context = {
    topic: function(client) {
      var nameSplit = this.context.name.split(/ +/)
        , method = nameSplit[0].toLowerCase()
        , path = nameSplit[1]

      request = _.extend({
        method: method,
        path: path
      }, request)

      return client[(method === 'delete') ? 'del' : method](request)
    }
  }

  if(response.status) {
    context['should respond with a ' + response.status] = status(response.status)
  }
  if(response.headers) {
    _.each(response.headers, function(value, key) {
      context['should respond with ' + key] = header(key, value)
    })
  }
  if(vows) {
    _.each(vows, function(vow, name) {
      context[name] = vow
    })
  }

  return context
}
