
var vows = require('vows')
  , assert = require('assert')
  , speck = require('../')

// vows
batches = [
  { 'isBuffer called with buffer': {
      topic: function() {
        var buffer = new Buffer('foobar')

        return buffer
      },
      'should pass': function(buffer) {
        assert.isBuffer(buffer)
      }
    },
    'isBuffer called with non-buffer': {
      topic: function() {
        return 'test string'
      },
      'should fail': function(str) {
        assert.throws(function() {
          assert.isBuffer(str)
        }, assert.AssertionError)
      }
    }
  }
]

suite = vows.describe('ASSERT')

batches.forEach(function(batch) {
  suite.addBatch(batch)
})

suite.export(module)
